package servermsg;

public class RecentUpdatesRequest extends ServerMsg {
	private static final long serialVersionUID = 201009301147L;
	public static final short TYPE = 51;
	
	//mark == 1: request for all the recent statuses from a specific time (==updateTime)
	//mark == 2: request for the new statuses for a specific user (with Id == objId) from a specific time (==updateTime)
	//if updateTime == -1, return the recent 20 tweets
	private int mark;
	private String objId = null;
	private long updateTime;
	
	public RecentUpdatesRequest(String uid, long stime, int m, String oid, long udt) {
		super(uid, stime, false);
		
		mark = m;
		objId = oid;
		updateTime = udt;
	}
	
	public int getMark() {
		return mark;
	}
	
	public String getObjId() {
		return objId;
	}
	
	public long getUpdateTime() {
		return updateTime;
	}
	
	public short getType() {
		return TYPE;
	}
}
