package servermsg;

import java.io.Serializable;

//the ancestor class for all the CS-model msg
public abstract class ServerMsg implements Serializable {
	protected static final long serialVersionUID = 201009301058L;
	
	protected String userId;
	protected long sendTime;
	protected long recvTime;
	
	//io == true:  incoming msg, i.e., response from server
	//io == false: outcoming msg, i.e., request to server
	protected boolean io; 
	
	public ServerMsg(String uid, long st, boolean m) {
		userId 	 = uid;
		sendTime = st;
		io 		 = m;
	}
	
	public boolean getIO() {
		return io;
	}
	
	public String getUserId() {
		return userId;
	}
	
	public long getSendTime() {
		return sendTime;
	}
	
	public long getRecvTime() {
		return recvTime;
	}
	
	abstract public short getType(); 
}
