package database;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import toolbox.TrafficLog;

public class TrafficAnalysisXMLDB /*extends XMLDB*/ {
	private String trafficfile;
	
	public TrafficAnalysisXMLDB(String path) {
		trafficfile = path;
	}
	
	public synchronized void addTrafficLog(TrafficLog tl) {
		try {
			PrintWriter os = new PrintWriter(new BufferedWriter(new FileWriter(trafficfile, true)));
			os.println(tl.toString());
			os.close();
		} catch (IOException e) {
			System.out.println("error in addTrafficLog!");
			e.printStackTrace();
		}
	}
	
	/*
	public TrafficAnalysisXMLDB(String dir, String path, String root) {
		super(dir, path, root);
	}
	
	public synchronized void addTrafficLog(TrafficLog tl) {
		boolean t = false;
		while(t == false) {
			try {
				SAXBuilder builder = new SAXBuilder();
				Document doc = builder.build(path);

				Element root = doc.getRootElement();
			
				Element element0 = new Element("time");
				element0.setAttribute("time", new Long(tl.getRTime()).toString());

				Element element1 = new Element("traffic");
				element1.setText(String.valueOf(tl.getTraffic()));
			
				Element element2 = new Element("mark");
				element2.setText(tl.getMark());

				Element element3 = new Element("isRead"); //actually here is for "inout"
				element3.setText(tl.getInOut());
			
				Element element4 = new Element("fromid");
				element4.setText(tl.getFromId());
			
				Element element5 = new Element("toid");
				element5.setText(tl.getToId());
				
				Element element6 = new Element("redundancy");
				element6.setText(tl.getRedundancy());
				
				Element element7 = new Element("sendtime");
				element7.setText(String.valueOf(tl.getSendTime()));
				
				Element element8 = new Element("recvtime");
				element8.setText(String.valueOf(tl.getRecvTime()));
				
				Element element9 = new Element("hops");
				element9.setText(String.valueOf(tl.getHops()));
				
				Element element10 = new Element("type");
				element10.setText(String.valueOf(tl.getType()));
				
				Element element11 = new Element("contentlength");
				element11.setText(String.valueOf(tl.getContentLength()));
				
				Element element12 = new Element("gossiptime");
				element12.setText(String.valueOf(tl.getGossipTime()));
				
				Element element13 = new Element("gossiphops");
				element13.setText(String.valueOf(tl.getGossipHops()));
			
				element0.addContent(element1);
				element0.addContent(element2);
				element0.addContent(element3);
				element0.addContent(element4);
				element0.addContent(element5);
				element0.addContent(element6);
				element0.addContent(element7);
				element0.addContent(element8);
				element0.addContent(element9);
				element0.addContent(element10);
				element0.addContent(element11);
				element0.addContent(element12);
				element0.addContent(element13);

				//root.addContent(0, element0);
				root.addContent(element0);
				doc.setRootElement(root);
			
				XMLOutputter out = new XMLOutputter();
				out.output(doc, new FileOutputStream(path));
				t = true;

			} catch(JDOMException e1) {
				System.out.println("JDOMException @ addTrafficLog in TrafficAnalysisXMLDB, let's start a new xml file");
				//e1.printStackTrace();
				xmlFailureHandler.setupNewFile();
			} catch(FileNotFoundException e2) {
				System.out.println("FileNotFoundException @ addTrafficLog in TrafficAnalysisXMLDB");
			} catch(IOException e3) {
				System.out.println("IOException @ addTrafficLog in TrafficAnalysisXMLDB");
			}
		}
	}
	*/
	
	/*
	private synchronized int findIndex(Element r, long t) {
		List<Element> ll = r.getChildren();
		for (Element e : ll) {
			if(t >= Long.valueOf(e.getAttributeValue("time"))) {
				return r.indexOf(e);
			}
		}
		return ll.size();
	}
	*/
	
	/*
	@SuppressWarnings("unchecked")
	public synchronized void xmlParsePrint() {
		try {
			SAXBuilder builder = new SAXBuilder();
			InputStream file = new FileInputStream(path);
			Document document = builder.build(file);
			Element root = document.getRootElement();
			List<Element> list = root.getChildren();
			for (Element e : list) {
				System.out.println(e.getAttributeValue("time")+" "+e.getChildText("traffic")+" "+e.getChildText("mark")+" "+e.getChildText("isRead")+""+e.getChildText("redundancy"));
			}
		} catch(JDOMException e1) {
			System.out.println("JDOMException @ xmlParsePrint in TrafficAnalysisXMLDB");
		} catch (IOException e2) {
			System.out.println("IOException @ xmlParsePrint in TrafficAnalysisXMLDB");
		}
	}
	*/
	
	/*
	public synchronized LinkedList<TrafficLog> getRecentTrafficLog(int bulk) {
		LinkedList<TrafficLog> sll = new LinkedList<TrafficLog>();
		while(true) {
			try {
				SAXBuilder builder = new SAXBuilder();
				InputStream file = new FileInputStream(path);
				Document document = builder.build(file);
				Element root = document.getRootElement();
				List<Element> list = root.getChildren();
				int i = 0;
				for (Element e : list) {
					sll.addLast( new TrafficLog(
							Long.valueOf(e.getAttributeValue("time")),
							Long.valueOf(e.getChildText("traffic")),
							Integer.valueOf(e.getChildText("contentlength")),
							Long.valueOf(e.getChildText("sendtime")),
							Long.valueOf(e.getChildText("recvtime")),
							Integer.valueOf(e.getChildText("hops")),
							Short.valueOf(e.getChildText("type")),
							e.getChildText("mark"),
							e.getChildText("isRead"),
							e.getChildText("fromid"),
							e.getChildText("toid"),
							e.getChildText("redundancy"),
							Long.valueOf(e.getChildText("gossiptime")),
							Integer.valueOf(e.getChildText("gossiphops"))
					));
					i += 1;
					if(i >= bulk) {
						break;
					}
				}
				break;
				
			} catch(JDOMException e1) {
				continue;
			} catch (IOException e2) {
				System.out.println("IOException @ getRecentTrafficLog in TrafficAnalysisXMLDB");
				continue;
			}
		}
		return sll;
	}
	*/
	/*
	public synchronized LinkedList<TrafficLog> getTrafficLog(long time) {
		LinkedList<TrafficLog> sll = new LinkedList<TrafficLog>();
	
		try {
			SAXBuilder builder = new SAXBuilder();
			InputStream file = new FileInputStream(path);
			Document document = builder.build(file);
			Element root = document.getRootElement();
			List<Element> list = root.getChildren();
			for (Element e : list) {
				long t = Long.valueOf(e.getAttributeValue("time"));
				if(t > time) {
					sll.addLast( new TrafficLog(
							Long.valueOf(e.getAttributeValue("time")),
							Long.valueOf(e.getChildText("traffic")),
							Integer.valueOf(e.getChildText("contentlength")),
							Long.valueOf(e.getChildText("sendtime")),
							Long.valueOf(e.getChildText("recvtime")),
							Integer.valueOf(e.getChildText("hops")),
							Short.valueOf(e.getChildText("type")),
							e.getChildText("mark"),
							e.getChildText("isRead"),
							e.getChildText("fromid"),
							e.getChildText("toid"),
							e.getChildText("redundancy"),
							Long.valueOf(e.getChildText("gossiptime")),
							Integer.valueOf(e.getChildText("gossiphops"))
					));
				} else {
					break;
				}
			}
		} catch(JDOMException e1) {
			System.out.println("JDOMException @ getRecentStatus in TrafficAnalysisXMLDB");
		} catch (IOException e2) {
			System.out.println("IOException @ getRecentStatus in TrafficAnalysisXMLDB");
		}
		return sll;
	}
	
	public static void printTrafficLogs(LinkedList<TrafficLog> tl) {
		Iterator<TrafficLog> iterator = tl.iterator();
		TrafficLog ts;
		while(iterator.hasNext()) {
			ts = iterator.next();
			System.out.println(ts.getRTime()+" "+ts.getTraffic()+" "+ts.getMark()+" "+ts.getInOut());
		}		
	}
	*/
	
	public static void main(String ars[]) {
		//String dir = "xml/" + "hello";
		
		//TrafficAnalysisXMLDB xmlDB = new TrafficAnalysisXMLDB(dir, dir+"/tl.xml", "testTl");
		//xmlDB.addTrafficLog(new TrafficLog(123, 345, "p", "n", "1", "2", "n"));
		//xmlDB.addTrafficLog(new TrafficLog(234, 345, "p", "n", "1", "2", "r"));
		//xmlDB.addTrafficLog(new TrafficLog(345, 345, "p", "n", "1", "2", "n"));
		//xmlDB.addTrafficLog(new TrafficLog(124, 345, "p", "n", "1", "2", "r"));
		//xmlDB.addTrafficLog(new TrafficLog(257, 345, "p", "n", "1", "2", "r"));
		
		//xmlDB.xmlParsePrint();
		//LinkedList<TrafficLog> ll = xmlDB.getRecentTrafficLog(10);
		//xmlDB.printTrafficLogs(ll);
	}
}
