package database;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.XMLOutputter;

public abstract class XMLDB {
	protected String dir;
	protected String path;
	protected String rootName;
	protected XMLFailureHandler xmlFailureHandler;
	
	public XMLDB(String dir, String path, String root) {
		File file = new File(path);
		this.dir = dir;
		this.path = path;
		this.rootName = root;
		this.xmlFailureHandler = new XMLFailureHandler(path, this);
		
		try {
			if(file.exists() == false) {
				File fDir = new File(dir);
				if(fDir.exists() == false) {
					fDir.mkdir();
				}
				file.createNewFile();
				createXmlDoc();
			}
		} catch(IOException e2) {
			e2.printStackTrace();
			System.out.println(file.getPath());
		}
	}
	
	public void printPath() {
		System.out.println("path = " + path);
	}
	
	public void createXmlDoc() {
		Element root = new Element(rootName);
		Document Doc = new Document(root);
		
		try {
			XMLOutputter XMLOut = new XMLOutputter();
			XMLOut.output(Doc, new FileOutputStream(path));
		} catch(FileNotFoundException e1) {
			System.out.print("FileNotFoundException@creatXmlDoc");
		} catch(IOException e2) {
			System.out.print("IOException@creatXmlDoc");
		}
	}
	
	abstract public void xmlParsePrint();
	
}
