package database;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Calendar;

public class XMLFailureHandler {
	String path;
	XMLDB db;
	
	public XMLFailureHandler(String path, XMLDB db) {
		this.path = path;
		this.db = db;
	}
	
	public void setupNewFile() {
		File file = new File(path);
		try {
			if(file.exists() == false) {
				file.createNewFile();
				db.createXmlDoc();
			} else { //file exists but is broken.
				String p = path.replaceAll(file.getName(), "")+"/"+file.getName().replace(".xml", "_")+Calendar.getInstance().getTimeInMillis()+".xml";
				System.out.println(p);
				if(file.renameTo(new File(p)) == false) {
					copyfile(path, p);
				}
				File newfile = new File(path);
				newfile.createNewFile();
				db.createXmlDoc();
			}
		} catch(FileNotFoundException fnf1) {
			System.out.println("FileNotFoundException @ failure handler");
		} catch(IOException ioe) {
			System.out.println("IOException @ failure handler");
		}
	}
	
	public static void copyfile(String srFile, String dtFile) {
		try {
			File f1 = new File(srFile);
		    File f2 = new File(dtFile);
		    InputStream in = new FileInputStream(f1);
		      
		    //For Append the file.
		    //OutputStream out = new FileOutputStream(f2,true);

		    //For Overwrite the file.
		    OutputStream out = new FileOutputStream(f2);

		    byte[] buf = new byte[1024];
		    int len;
		    while ((len = in.read(buf)) > 0){
		    	out.write(buf, 0, len);
		    }
		    in.close();
		    out.close();
		    System.out.println("File copied.");
		    
		} catch(FileNotFoundException ex){
		    System.out.println(ex.getMessage() + " in the specified directory.");
		    System.exit(0);
		} catch(IOException e){
		    System.out.println(e.getMessage());      
		}
	}
}
