package emulascript;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.Iterator;
import java.util.LinkedList;

import rice.environment.Environment;
import application.Cuckoo;

public class BootstrapGuardian {
	public static final int NUM_OF_GUARDIAN = 10;
	public static final int GUARDIAN_PORT = 9000;
	
	public static final String BOOT_NODE_IP = "./dhtBootNodeIpAddress";//should be raphael
	public static final String GUARDIAN_IDS = "./guardianIdList";
	
	private LinkedList<Cuckoo> myGuardians = new LinkedList<Cuckoo>();
	
	private Environment env;
	//private Cuckoo cuckoo;
	private InetSocketAddress bootaddress;
	private InetAddress bootaddr;
	private int bootport;
	
	private InetAddress bindaddr;
	
	public BootstrapGuardian() {
		// Loads pastry settings
		env = new Environment();
		env.getParameters().setString("nat_search_policy", "never");
		
		String bootIp = ThreadEmulator.getIpAddress(BOOT_NODE_IP);
		try {
			bootaddr = InetAddress.getByName(bootIp);
			bootport = BootstrapGuardian.GUARDIAN_PORT;
			bootaddress = new InetSocketAddress(bootaddr, bootport);
			
			bindaddr = InetAddress.getByName(ThreadEmulator.getIpAddress(ThreadEmulator.LOCAL_IP_ADDRESS));
		} catch(IOException ioe) {
			ioe.printStackTrace();
		}
		
		initGuardians();
		//Cuckoo cuckoo = new Cuckoo(env, "1", bootaddress, bindaddr, bindport);
		//myGuardians.addLast(cuckoo);
		//cuckoo.setBootstrap(true);
	}
	
	private void initGuardians() {
		try {
			BufferedReader is = new BufferedReader(new FileReader(GUARDIAN_IDS));
			String id;
			int i = GUARDIAN_PORT;
			while((id = is.readLine()) != null) {
				id = id.trim();
				int bindport = i;
				Cuckoo cuckoo = new Cuckoo(env, id, bootaddress, bindaddr, bindport);
				myGuardians.addLast(cuckoo);
				i ++;
			}
			is.close();
		} catch(IOException ioe) {
			ioe.printStackTrace();
		}
	}
	
	public void launchBootstrappingNodes() {
		Iterator<Cuckoo> iterator = myGuardians.iterator();
		while(iterator.hasNext()) {
			iterator.next().bootstrap();
		}
	}
	
	public static void main(String[] args) {
		BootstrapGuardian guard = new BootstrapGuardian();
		guard.launchBootstrappingNodes();
		System.out.println("-------guard launched--------");
	}
}
