package message;

import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.InputBuffer;
import rice.p2p.commonapi.rawserialization.OutputBuffer;

public class GossipFeedbackMsg extends CuckooMsg {
	private static final long serialVersionUID = 201008092210L;
	public  static final short TYPE = 30;
    
	private String statusId;
	
    //Constructors.
    public GossipFeedbackMsg(Id from, Id to, String fid, String tid, NodeHandle nh, long t, String stId) {
    	super(from, to, fid, tid, nh, t);
    	this.statusId = stId;
    }
	
	public short getType() {
		return TYPE;
	}

	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
		buf.writeUTF(statusId);
	}

	public GossipFeedbackMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
		statusId = buf.readUTF();
	}
	
	public String getStatusId() {
		return statusId;
	}
}
