package message;

import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.InputBuffer;
import rice.p2p.commonapi.rawserialization.OutputBuffer;

public class PartnerCancelMsg extends CuckooMsg {
	private static final long serialVersionUID = 201008081537L;
	public static final short TYPE = 15;
    
	private String commonFolloweeId;
	
    // Constructors.
    public PartnerCancelMsg(Id from, Id to, String fid, String tid, NodeHandle nh, long t, String cfid) {
    	super(from, to, fid, tid, nh, t);
    	commonFolloweeId = cfid;
    }
	
    //@Override: required by the "RawMessage" Interface
	public short getType() {
		return TYPE;
	}

	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
		buf.writeUTF(commonFolloweeId);
	}

	public PartnerCancelMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
		commonFolloweeId = buf.readUTF();
	}
	
	public String getCommonFolloweeId() {
		return commonFolloweeId;
	}
}
