package message;
import java.io.IOException;

import application.Profile;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.*;
import rice.p2p.util.BloomFilter;

public class ReqFollowMsg extends CuckooPiggybackMsg {
	private static final long serialVersionUID = 201004070625L;
	public static final short TYPE = 4;
    
    private String username;
    private String location;
	private String web;
	private String bio;
    
    // Constructors.
    public ReqFollowMsg(Id from, Id to, String fid, String tid, NodeHandle nh, long t, BloomFilter bf, Profile myProfile) {
    	super(from, to, fid, tid, nh, t, bf);
    	
    	this.username = myProfile.getUserName();
    	this.location = myProfile.getLocation();
    	this.web = myProfile.getWeb();
    	this.bio = myProfile.getBio();
    }
	
    //@Override: required by the "RawMessage" Interface
	public short getType() {
		return TYPE;
	}
    
	//@Override: required by the "RawMessage" Interface 
	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
		
	    buf.writeUTF(username);
	    buf.writeUTF(location);
	    buf.writeUTF(web);
	    buf.writeUTF(bio);
	}
	
	public ReqFollowMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
		
	    username = buf.readUTF();
	    location = buf.readUTF();
		web = buf.readUTF();
		bio = buf.readUTF();
	}
	
	public Profile getProfile() {
		return new Profile(fromUserId, username, location, web, bio);
	}
}

