package message;

import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.InputBuffer;
import rice.p2p.commonapi.rawserialization.OutputBuffer;
import rice.p2p.util.BloomFilter;

public class ReqNodeHandleMsg extends CuckooPiggybackMsg {
	private static final long serialVersionUID = 201007191754L;
	public static final short TYPE = 7;
	//ask for "direct" or "gossip" dissemination or "ack": 0 - direct; 1 - gossip; 2 - ack
	private int DoG;
	private String authorId; //for gossip
    
    // Constructors.
    public ReqNodeHandleMsg(Id from, Id to, String fid, String tid, NodeHandle nh, long t, BloomFilter bf, int dog, String aid) {
    	super(from, to, fid, tid, nh, t, bf);
    	this.DoG = dog;
    	authorId = aid;
    }
	
    //@Override: required by the "RawMessage" Interface
	public short getType() {
		return TYPE;
	}
	
	public String getAuthorId() {
		return authorId;
	}

	public int getDoG() {
		return DoG;
	}
	
	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
		buf.writeInt(DoG);
		buf.writeUTF(authorId);
	}

	public ReqNodeHandleMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
		DoG = buf.readInt();
		authorId = buf.readUTF();
	}
	
	public String toString() {
		return "ReqNodeHandleMsg from [" + fromUserId + "], to [" + toUserId + "]"; 
	}
}
