package message;
import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.*;
import rice.p2p.util.BloomFilter;

public class ReqStatusMsg extends CuckooPiggybackMsg {
	private static final long serialVersionUID = 201004010358L;
	public static final short TYPE = 11;
	
    private long time;
    
    private boolean isreplied; //to indicate whether this message is replied or not -- USED FOR MEASUREMENT.
    private int achops;  //actually hops needed to get the status -- USED FOR MEASUREMENTS.
    private long actime; //actually time needed to get the status -- USED FOR MEASUREMENTS.
    
    // Constructor
    public ReqStatusMsg(Id from, Id to, String fid, String tid, NodeHandle nh, long t, BloomFilter bf, long time) {
    	super(from, to, fid, tid, nh, t, bf);
    	this.time = time;
    	
    	this.isreplied = false;
    	this.achops = -1;
    	this.actime = -1;
    }

	//@Override: required by the "RawMessage" Interface
	public short getType() {
		return TYPE;
	}

	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
	    buf.writeLong(time);
	    buf.writeBoolean(isreplied);
	    buf.writeInt(achops);
	    buf.writeLong(actime);
	}
	
	public long getTime() {
		return time;
	}
	
	public boolean getIsReplied() {
		return isreplied;
	}

	public int getAcHops() {
		return achops;
	}
	
	public void setAcHops(int ach) {
		achops = ach;
	}
	
	public long getAcTime() {
		return actime;
	}
	
	public void setAcTime(long act) {
		actime = act;
	}
	
	public void setIsReplied(boolean ir) {
		isreplied = ir;
	}
	
	public ReqStatusMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
	    time = buf.readLong();
	    isreplied = buf.readBoolean();
	    achops = buf.readInt();
	    actime = buf.readLong();
	}
}
