package servermsg;

public class RequestRecentUpdates extends ServerMessage {

	public static final short TYPE = 51;
	private static final long serialVersionUID = 201009301147L;
	
	/*
	 * mark == 1: request for all the recent statuses from a specific time (==updateTime)
	 * mark == 2: request for the new statuses for a specific user (with Id == objId) from a specific time (==updateTime)
	 * if updateTime == -1, return the recent 20 tweets
	 */
	private int mark;
	
	private String objId = null;
	private long updateTime;
	
	public RequestRecentUpdates(String MyUsrID, long sentTime, long recvTime, int RequestType, 
			String RequestedUsrID, long updateTime) {
		super(MyUsrID, sentTime, recvTime, false);
		this.mark = RequestType;
		this.objId = RequestedUsrID;
		this.updateTime = updateTime;
	}
	
	public int getMark() {
		return mark;
	}
	
	public String getObjId() {
		return objId;
	}
	
	public long getUpdateTime() {
		return updateTime;
	}
	
	public short getType() {
		return TYPE;
	}
}
