package toolbox;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import database.PartnerXMLDB;

public class PartnerMap {
	//public static final int NUM_OF_PARTNERS = 5;
	public static final int FOR_SEND = 1;
	public static final int FOR_FWRD = 2;
	public static final int WRITE_MARK = 5;
	
	//String: followeeId, PartnerQueue: containing partners
	//public HashMap<String, PartnerQueue> oldPartnerMap = new HashMap<String, PartnerQueue>();
	//public HashMap<String, PartnerQueue> newPartnerMap = new HashMap<String, PartnerQueue>();
	public HashMap<String, HashMap<String, UTPair>> partnerIndice4Send = new HashMap<String, HashMap<String, UTPair>>();
	public HashMap<String, HashMap<String, UTPair>> partnerIndice4Fwrd = new HashMap<String, HashMap<String, UTPair>>();
	
	PartnerXMLDB partnerXMLDB;
	
	public PartnerMap(PartnerXMLDB db) {
		partnerXMLDB = db;
		//initial for the oldPartnerMap
		//partnerXMLDB.initPartnerList(this);
	}
	
	//Initially add to the oldPartnerMap (only for oldPartnerMap)
	//Used at the beginning of this session
	/*
	public void initAdd(String id, Partner p) {
		PartnerQueue opqueue = oldPartnerMap.get(id);
		if(opqueue == null) {
			opqueue = new PartnerQueue(id);
			opqueue.addPartner(p);
			oldPartnerMap.put(id, opqueue);
		} else {
			opqueue.addPartner(p);
		}
	}*/
	/*
	//Add at runtime (when a routing msg is listened)
	public void runtimeAdd(String id, Partner p) {
		//System.out.println("******************id: " + id + ", p: " + p.getPartnerId());
		PartnerQueue opqueue = oldPartnerMap.get(id);
		if(opqueue == null) {
			opqueue = new PartnerQueue(id);
			opqueue.addPartner(p);
			oldPartnerMap.put(id, opqueue);
		} else if(opqueue.getLength() < NUM_OF_PARTNERS) {
			opqueue.addPartner(p);
		} else if(opqueue.contains(p) == true) {
			opqueue.refresh(p); //automatically increase the health
		} else {
			add2NewMap(id, p);
		}
	}
	
	private void add2NewMap(String id, Partner p) {
		PartnerQueue npqueue = newPartnerMap.get(id);
		if(npqueue == null) {
			npqueue = new PartnerQueue(id);
			npqueue.addPartner(p);
			newPartnerMap.put(id, npqueue);
		} else if(npqueue.contains(p) == true) {
			npqueue.refresh(p); //automatically increase the health
		} else {
			npqueue.addPartner(p);
		}
	}
	
	//Compete add to oldPartnerMap
	//Used at the end of this session
	private void competeAdd(String id, Partner p) {
		PartnerQueue opqueue = oldPartnerMap.get(id);
		if(opqueue == null) {
			opqueue = new PartnerQueue(id);
			opqueue.addPartner(p);
			oldPartnerMap.put(id, opqueue);
		} else {
			opqueue.addPartner(p);
		}
	}
	*/
	
	public List<String> getPartners(String id) {
		return partnerXMLDB.getPartners(id);
	}
	
	public void monitorPartner(String fid, String pid) {
		updateHealth(fid, pid, FOR_FWRD, HealthIndex.INCR_BLOOD);
		if(partnerIndice4Fwrd.keySet().size() >= WRITE_MARK) {
			writeBack(FOR_FWRD);
		}
	}
	
	public void increaseHealth(String fid, String pid) {
		updateHealth(fid, pid, FOR_SEND, HealthIndex.INCR_BLOOD);
	}
	
	public void decreaseHealth(String fid, String pid) {
		updateHealth(fid, pid, FOR_SEND, HealthIndex.DECR_BLOOD);
	}
	
	private void updateHealth(String fid, String pid, int forWhat, int INoDR) {
		HashMap<String, HashMap<String, UTPair>> hmap = null;
		if(forWhat == FOR_SEND) {
			hmap = partnerIndice4Send;
		} else if(forWhat == FOR_FWRD){
			hmap = partnerIndice4Fwrd;
		}
		
		HashMap<String, UTPair> pairs = hmap.get(fid);
		if(pairs == null) {
			HashMap<String, UTPair> map = new HashMap<String, UTPair>();
			map.put(pid, new UTPair(pid, 0, INoDR));
			hmap.put(fid, map);
		} else {
			UTPair utp = pairs.get(pid);
			if(utp == null) {
				pairs.put(pid, new UTPair(pid, 0, INoDR));
			} else {
				utp.health += INoDR;
			}
		}
	}
	
	public void writeBack(int forWhat) {
		if(forWhat == FOR_SEND) {
			partnerXMLDB.refreshIndex(partnerIndice4Send);
			partnerIndice4Send.clear();
		} else if(forWhat == FOR_FWRD) {
			partnerXMLDB.refreshIndex(partnerIndice4Fwrd);
			partnerIndice4Fwrd.clear();
		}
	}
	
	public void printIndice(int forWhat) {
		HashMap<String, HashMap<String, UTPair>> hmap = null;
		if(forWhat == FOR_SEND) {
			hmap = partnerIndice4Send;
		} else if(forWhat == FOR_FWRD){
			hmap = partnerIndice4Fwrd;
		}
		
		Set<String> set = hmap.keySet();
		Iterator<String> iterator = set.iterator();
		while(iterator.hasNext()) {
			String fid = iterator.next();
			System.out.println("followeeId [" + fid + "] -- ");
			HashMap<String, UTPair> map = hmap.get(fid);
			Set<String> fset = map.keySet();
			Iterator<String> iter = fset.iterator();
			while(iter.hasNext()) {
				String uid = iter.next();
				UTPair pair = map.get(uid);
				System.out.print("<" + pair.userId + ", " + pair.health + "> ");
			}
		}
	}
	
	/*
	//Compare the new partners with the old guys
	public void writeBack() {
		//HashMap<String, PartnerQueue> rePartnerMap = new HashMap<String, PartnerQueue>();
		
		Set<String> keyset = newPartnerMap.keySet();
		Iterator<String> iterator = keyset.iterator();
		while(iterator.hasNext()) {
			String id = iterator.next();
			List<Partner> pl= newPartnerMap.get(id).getPartnerList();
			
			Iterator<Partner> pIterator = pl.iterator();
			while(pIterator.hasNext()) {
				Partner tmpp = pIterator.next();
				competeAdd(id, tmpp);
			}
		}
		//System.out.println("****************************");
		//printPartnerMap(1);
		partnerXMLDB.writeBack(oldPartnerMap);
	}
	*/
	/*
	//i == 1: print oldPartnerMap
	//i == 2: print newPartnerMap
	public void printPartnerMap(int i) {
		HashMap<String, PartnerQueue> partnerMap;
		if(i == 1) {
			partnerMap = oldPartnerMap;
		} else {
			partnerMap = newPartnerMap;
		}
		
		Set<String> keyset = partnerMap.keySet();
		Iterator<String> iterator = keyset.iterator();
		while(iterator.hasNext()) {
			String id = iterator.next();
			System.out.print("followee (" + id + "): ");
			partnerMap.get(id).printQueue();
		}
	}
	
	public void printPartnerMap() {
		System.out.println("Old Partners' Map: --- ");
		printPartnerMap(1);
		System.out.println("New Partners' Map: --- ");
		printPartnerMap(2);
	}
	*/
	/*
	/////////////////////////////////////////////////////////////////////
	//Queue with fixed length
	public class PartnerQueue {
		private String followeeId;
		private ArrayList<Partner> partnerList = new ArrayList<Partner>();
		private int length;
		
		public PartnerQueue(String fid) {
			followeeId = fid;
			length = 0;
		}
		
		public void addPartner(Partner p) {
			int index = indexOf(p);
			if(index != -1) {
				//update the partner
				Partner up = partnerList.get(index);
				up.refresh(p);
			} else {
				if(partnerList.size() < NUM_OF_PARTNERS) {
					partnerList.add(p);
					length += 1;
				} else if (partnerList.size() == NUM_OF_PARTNERS) {
					replacement(p);
				} else {
					System.out.println("error!!! -- neighborList.size > length!!!");
					System.exit(1);
				}
			}
		}
		
		public int indexOf(Partner p) {
			for(int i=0; i<partnerList.size(); i++) {
				if(partnerList.get(i).getPartnerId().compareTo(p.getPartnerId()) == 0) {
					return i;
				}
			}
			return -1;
		}
		
		public void increaseHealth(String uid) {
			Iterator<Partner> iterator = partnerList.iterator();
			while(iterator.hasNext()) {
				Partner tp = iterator.next();
				if(tp.getPartnerId().compareTo(uid) == 0) {
					tp.increaseHealth();
				}
			}
		}
		
		public void decreaseHealth(String uid) {
			Iterator<Partner> iterator = partnerList.iterator();
			while(iterator.hasNext()) {
				Partner tp = iterator.next();
				if(tp.getPartnerId().compareTo(uid) == 0) {
					tp.decreaseHealth();
				}
			}
		}
		
		public boolean contains(Partner p) {
			Iterator<Partner> iterator = partnerList.iterator();
			while(iterator.hasNext()) {
				if(iterator.next().getPartnerId().compareTo(p.getPartnerId()) == 0) {
					return true;
				}
			}
			return false;
		}
		
		public void refresh(Partner p) {
			Iterator<Partner> iterator = partnerList.iterator();
			while(iterator.hasNext()) {
				Partner tp = iterator.next();
				if(tp.getPartnerId().compareTo(p.getPartnerId()) == 0) {
					tp.refresh(p);
				}
			}
		}
		
		public void refresh(Partner p, int index) {
			Partner tp = partnerList.get(index);
			tp.refresh(p);
		}
		
		public void printQueue() {
			Iterator<Partner> iterator = partnerList.iterator();
			while(iterator.hasNext()) {
				Partner p = iterator.next();
				System.out.print(p.getPartnerId() + "(h:" + p.getHealthIndex() + ", s:" + p.getSimilarity() + ") ");
			}
			System.out.println();
		}
		
		//Most important, should consider the health and the similarity
		public void replacement(Partner p) {
			//Iterator<Partner> iterator = partnerList.iterator();
			
			for(int i=0; i<partnerList.size(); i++) {
				Partner tp = partnerList.get(i);
				if(p.getHealthIndex() > tp.getHealthIndex()) {
					deletePartner(i);
					addPartner(p);
				} else if(p.getHealthIndex() == tp.getHealthIndex()) {
					if(p.getSimilarity() >= tp.getSimilarity()) {
						deletePartner(i);
						addPartner(p);
					}
				}
			}
			
			//partnerMap.writeBack();
		}
		
		public void deletePartner(int index) {
			partnerList.remove(index);
			length -= 1;
		}
		
		public void deletePartner(String pid) {
			for(int i=0; i<partnerList.size(); i++) {
				if(partnerList.get(i).getPartnerId().compareTo(pid) == 0) {
					partnerList.remove(i);
					length -= 1;
					return;
				}
			}
		}
		
		public String partners2string() {
			String result = "";
			Iterator<Partner> iterator = partnerList.iterator();
			while(iterator.hasNext()) {
				result = result + iterator.next().getPartnerId() + "#";
			}
			return result;
		}
		
		public String healthes2string() {
			String result = "";
			Iterator<Partner> iterator = partnerList.iterator();
			while(iterator.hasNext()) {
				result = result + iterator.next().getHealthIndex() + "#";
			}
			return result;
		}
		
		public String sims2string() {
			String result = "";
			Iterator<Partner> iterator = partnerList.iterator();
			while(iterator.hasNext()) {
				result = result + iterator.next().getSimilarity() + "#";
			}
			return result;
		}
		
		public int getLength() {
			return length;
		}
		
		public String getFolloweeId() {
			return followeeId;
		}
		
		public List<Partner> getPartnerList() {
			return partnerList;
		}
		
		public List<String> getPartnerIds() {
			ArrayList<String> al = new ArrayList<String>();
			Iterator<Partner> iterator = partnerList.iterator();
			while(iterator.hasNext()) {
				al.add(iterator.next().getPartnerId());
			}
			return al;
		}
	}*/
}