package zoo;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;

import application.Status;
import database.GossipAnalysisXMLDB;
import database.StatusXMLDB;

public class GossipAnalysis {
	public static final String DIR = "/home/donatello/CuckooGossipXml1216/xml/";
	
	public static final String IDLIST = "/home/donatello/TwData_30thsd/IdListAll";
	
	public static final String IDLIST_DIR = "/home/donatello/CuckooGossipXml1216/idlists/";
	
	public static final String[] BIG_IDS = {"5490392", "11522502", "14164855", "18915240", "11738562"};
	public static final int[] gInterval = {45, 45, 43, 25, 13};
	public static final int[] gStart = {15, 30, 45, 7, 27};
	
	public static final int StartUp = 2;
	
	public static final int BULKS = 500;
	
	public int onlineUsers2(long time, String followeeId) {
		int count = 0;
		//int c = 0;
		try {
			File file = new File(IDLIST_DIR);
			File[] idfiles = file.listFiles();
			for(int i=0; i<idfiles.length; i++) {
				
			BufferedReader inputStream = new BufferedReader(new FileReader(idfiles[i]));
			String upline;
			while((upline = inputStream.readLine()) != null) {
				upline = upline.trim();
				String[] upsplit = upline.split("#");
				
				String userId = upsplit[0];
				
				if(isFollowee(userId, followeeId) == true) {
				
					//c ++;
					//if(count % 10000 == 0) {System.out.println(count);}
					BufferedReader eventStream = new BufferedReader(new FileReader(DIR+userId+"/"+userId+"_event"));
					String line = eventStream.readLine();
					String[] split = line.split(" ");
					long firstWait = Long.valueOf(split[1]);
				
					if(time > firstWait) {
						count ++;
					}
				}
			}
			inputStream.close();
			//System.out.println(c);
			}
			
		} catch(Exception e) {
			e.printStackTrace();
		}
		return count;
	}
	
	public boolean isFollowee(String userId, String followeeId) {
		boolean re = false;
		try {
			BufferedReader input = new BufferedReader(new FileReader(DIR+userId+"/"+userId+"_followee"));
			String fid;
			while((fid = input.readLine()) != null) {
				fid = fid.trim();
				if(fid.compareTo(followeeId) == 0) {
					re = true;
				}
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
		return re;
	}
	
	public int onlineUsers(long time) {
		int count = 0;
		//int c = 0;
		try {
			BufferedReader inputStream = new BufferedReader(new FileReader(IDLIST));
			String userId;
			while((userId = inputStream.readLine()) != null) {
				userId = userId.trim();
				
				//c ++;
				//if(count % 10000 == 0) {System.out.println(count);}
				BufferedReader eventStream = new BufferedReader(new FileReader(DIR+userId+"/"+userId+"_event"));
				String line = eventStream.readLine();
				String[] split = line.split(" ");
				long firstWait = Long.valueOf(split[1]);
				
				if(time > firstWait) {
					count ++;
				}
			}
			inputStream.close();
			//System.out.println(c);
			
		} catch(Exception e) {
			e.printStackTrace();
		}
		return count;
	}
	
	public void print() {
		for(int i=0; i<BIG_IDS.length; i++) {
			printPiecesOfShit(i);
		}
	}
	
	public void printPiecesOfShit(int index) {
		Status[] ss = filterErrs(BIG_IDS[index]);
		
		double avgSent = 0.0;
		double avgRecv = 0.0;
		double number = 0.0;
		
		for(int i=0; i<ss.length; i++) {
			int sent = getSent(ss[i].getAuthorId(), ss[i].getStatusId());
			int recv = calcRecv(ss[i]);
			
			long time = (gStart[index] - StartUp + gInterval[index] * (i+9)) * 60000;
			int onlineusers = onlineUsers2(time, BIG_IDS[index]);
			
			if(recv < onlineusers) {
				avgSent += sent*1.0/onlineusers * 100.0;
				avgRecv += recv*1.0/onlineusers * 100.0;
				number += 1.0;
			} else {
				System.out.println(sent);
				System.out.println(recv);
				System.out.println(onlineusers);
			}
		}
		System.out.println(avgSent/number);
		System.out.println(avgRecv/number);
		System.out.println("-----------------------");
	}
	
	public Status[] filterErrs(String userId) {
		StatusXMLDB xmlDB = new StatusXMLDB(DIR+userId, DIR+userId+"/mystatus.xml", "myStatus");
		GossipAnalysisXMLDB gossipDB = new GossipAnalysisXMLDB(DIR+userId, DIR+userId+"/gossipanalysis.xml", "gossipanalysis");
		
		Status[] statuses = xmlDB.getRecentStatuses(BULKS);
		LinkedList<Status> ll = new LinkedList<Status>();
		
		for(int i=0; i<statuses.length; i++) {
			//System.out.println(statuses[i].getStatusId() + " " + statuses[i].getText() + " " + new Date(statuses[i].getTime()));
			//System.out.println();
			if(gossipDB.getSent(statuses[i].getStatusId()) > 10) {
				ll.addFirst(statuses[i]);
			}
		}
		//System.out.println(ll.size());
		int length = ll.size();
		Status[] fs = new Status[length];
		for(int i=0; i<fs.length; i++) {
			fs[i] = ll.removeFirst();
		}
		
		return fs;
	}
	
	public int calcRecv(Status s) {
		int count = 0;
		//int c = 0;
		try {
			BufferedReader inputStream = new BufferedReader(new FileReader(IDLIST));
			String userId;
			while((userId = inputStream.readLine()) != null) {
				userId = userId.trim();
				
				//c ++;
				//if(count % 10000 == 0) {System.out.println(count);}
				StatusXMLDB tmpXmlDB = new StatusXMLDB(DIR+userId, DIR+userId+"/followeestatus.xml", "followeeStatus");
				if(tmpXmlDB.recentExist(s, 1000) == true) {
					count++;
				}
			}
			inputStream.close();
			//System.out.println(c++);
			
		} catch(Exception e) {
			e.printStackTrace();
		}
		return count;
	}
	
	public int getSent(String userId, String statusId) {
		GossipAnalysisXMLDB gossipDB = new GossipAnalysisXMLDB(DIR+userId, DIR+userId+"/gossipanalysis.xml", "gossipanalysis");
		//xmlDB.xmlParsePrint();
		return gossipDB.getSent(statusId);
	}
	
	public void printMyStatuses(String userId) {
		StatusXMLDB xmlDB = new StatusXMLDB(DIR+userId, DIR+userId+"/mystatus.xml", "myStatus");
		GossipAnalysisXMLDB gossipDB = new GossipAnalysisXMLDB(DIR+userId, DIR+userId+"/gossipanalysis.xml", "gossipanalysis");
		//xmlDB.xmlParsePrint();
		
		Status[] statuses = xmlDB.getRecentStatuses(BULKS);
		
		for(int i=0; i<statuses.length; i++) {
			System.out.println(statuses[i].getStatusId() + " " + statuses[i].getText() + " " + new Date(statuses[i].getTime()));
			System.out.println(gossipDB.getSent(statuses[i].getStatusId()));
		}
	}
	
	public void printGossipAnalysisXml(String userId) {
		GossipAnalysisXMLDB gossipDB = new GossipAnalysisXMLDB(DIR+userId, DIR+userId+"/gossipanalysis.xml", "gossipanalysis");
		gossipDB.xmlParsePrint();
	}
	
	public static void main(String ars[]) {
		GossipAnalysis ga = new GossipAnalysis();
		//ga.printMyStatuses(BIG_IDS[0]);
		
		//ga.printGossipAnalysisXml(BIG_IDS[0]);
		//ga.filterErrs(BIG_IDS[0]);
		
		ga.printPiecesOfShit(2);
		
		//ga.print();
		//System.out.println(ga.onlineUsers((15+45)*60000));
	}
}
