package zoo;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;

import application.Status;

import database.GossipAnalysisXMLDB;
import database.StatusXMLDB;

public class GossipHopAnalysis {
	public static final String G_INPUT = "/home/donatello/CuckooGossipXml1216/xml/";
	
	public static final String IDLIST = "/home/donatello/TwData_30thsd/IdListAll";
	public static final String FILTERED_IDLIST = "/home/donatello/CuckooGossipXml1216/FilteredIdList";
	
	public static final String OUTPUT = "/home/donatello/CuckooGossipXml1216/gossiphops.dat";
	public static final String RE_OUTPUT = "/home/donatello/CuckooGossipXml1216/red.dat";
	
	public static final String ALL = "/home/donatello/CuckooGossipXml1216/gossiphopsall.dat";
	public static final String RED = "/home/donatello/CuckooGossipXml1216/gossiphopsred.dat";
	
	public void testNumberOfUser() {
		try {
			BufferedReader inputStream = new BufferedReader(new FileReader(IDLIST));
			PrintWriter os = new PrintWriter(new BufferedWriter(new FileWriter(FILTERED_IDLIST)));
			String userId;
			int count = 0;
			while((userId = inputStream.readLine()) != null) {
				userId = userId.trim();
				count ++;
				
				if(count % 10000 == 0) {System.out.println(count);}
				
				String trafficfilepath = G_INPUT + userId + "/trafficanalysis.dat";
				File trafficfile = new File(trafficfilepath);
				if(trafficfile.exists()) {
					os.println(userId);
				} 
			}
			os.flush();
			os.close();
			inputStream.close();
			
			System.out.println(count);
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void printTrafficToFile() {
		try {
			BufferedReader inputStream = new BufferedReader(new FileReader(FILTERED_IDLIST));
			PrintWriter os = new PrintWriter(new BufferedWriter(new FileWriter(OUTPUT)));
			String userId;
			int count = 0;
			while((userId = inputStream.readLine()) != null) {
				userId = userId.trim();
				
				count ++;
				if(count % 10000 == 0) {System.out.println(count);}
				
				String path = G_INPUT + userId + "/trafficanalysis.dat";
				BufferedReader trafficdat = new BufferedReader(new FileReader(path)); 
				
				String trafficline = null;
				while((trafficline = trafficdat.readLine()) != null) {
					trafficline = trafficline.trim();
					
					String[] split = trafficline.split("#");
					//System.out.println(split[8]);
					
					if(split[6].compareTo("23") == 0) {
						//System.out.println(line);
						if(split[11].compareTo("r") == 0) {
							//System.out.println(split[12]);
							os.println(split[13]);
						}
					}
				}
				 
			}

			os.flush();
			os.close();
			inputStream.close();
			
			System.out.println(count);
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void getRedundancy() {
		try {
			BufferedReader inputStream = new BufferedReader(new FileReader(FILTERED_IDLIST));
			PrintWriter os = new PrintWriter(new BufferedWriter(new FileWriter(RE_OUTPUT)));
			String userId;
			int count = 0;
			while((userId = inputStream.readLine()) != null) {
				userId = userId.trim();
				
				count ++;
				if(count % 10000 == 0) {System.out.println(count);}
				
				String path = G_INPUT + userId + "/trafficanalysis.dat";
				BufferedReader trafficdat = new BufferedReader(new FileReader(path)); 
				
				ArrayList<Short> allhops = new ArrayList<Short>();
				ArrayList<Short> redhops = new ArrayList<Short>();
				
				String trafficline = null;
				while((trafficline = trafficdat.readLine()) != null) {
					trafficline = trafficline.trim();
					
					String[] split = trafficline.split("#");
					//System.out.println(split[8]);
					
					if(split[6].compareTo("23") == 0) {
						//System.out.println(line);
						if(split[11].compareTo("r") != 0) {
							//System.out.println(split[12]);
							allhops.add(Short.valueOf(split[13]));
						} else {
							redhops.add(Short.valueOf(split[13]));
						}
					}
				}
				
				StatusXMLDB tmpXmlDB = new StatusXMLDB(G_INPUT+userId, G_INPUT+userId+"/followeestatus.xml", "followeeStatus");
				Status[] sts = tmpXmlDB.getRecentStatuses(10000);
				
				int infection = sts.length;
				int redundant = redhops.size();
				/*
				int infection = allhops.size() - redhops.size();
				if(infection < 0) {
					System.out.println("userId = " + userId);
					System.out.println("all = " + allhops.size());
					System.out.println("red = " + redhops.size());
					System.out.println("------------");
				}
				
				while(redhops.size()>0) {
					Short rhop = redhops.remove(0);
					
					for(int i=0; i<allhops.size(); i++) {
						if(rhop.equals(allhops.get(i)) == true) {
							allhops.remove(i);
							break;
						}
					}
				}
				
				int red = allhops.size();
				double avgRed = red*1.0/infection;
				if(infection != 0) {
					os.println(avgRed);
				}
				*/
				if(infection != 0) {
					int avgRed = (int) (redundant*1.0/infection);
					os.println(avgRed);
				}
			}

			os.flush();
			os.close();
			inputStream.close();
			
			System.out.println(count);
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void getInfection() {
		try {
			BufferedReader allinput = new BufferedReader(new FileReader(ALL));
			BufferedReader redinput = new BufferedReader(new FileReader(RED));
			PrintWriter os = new PrintWriter(new BufferedWriter(new FileWriter(OUTPUT)));
			
			ArrayList<Short> allhops = new ArrayList<Short>();
			ArrayList<Short> redhops = new ArrayList<Short>();
			
			String hopLine;
			while((hopLine = allinput.readLine()) != null) {
				allhops.add(Short.valueOf(hopLine.trim()));
			}
			
			while((hopLine = redinput.readLine()) != null) {
				redhops.add(Short.valueOf(hopLine.trim()));
			}
			
			System.out.println("all size: " + allhops.size());
			System.out.println("red size: " + redhops.size());
			
			while(redhops.size()>0) {
				Short rhop = redhops.remove(0);
				
				for(int i=0; i<allhops.size(); i++) {
					if(rhop.equals(allhops.get(i)) == true) {
						allhops.remove(i);
						break;
					}
				}
			}
			
			System.out.println(allhops.size());
			
			Iterator<Short> iterator = allhops.iterator();
			while(iterator.hasNext()) {
				os.println(iterator.next());
			}			
			os.flush();
			os.close();
			
		} catch(Exception e) {
			e.printStackTrace();
		}			
	}
	
	public static void main(String[] args) {
		GossipHopAnalysis gha = new GossipHopAnalysis();
		//gha.testNumberOfUser();
		gha.getRedundancy();
	}
}
